import { __decorate, __read, __param, __assign } from 'tslib';
import { Injectable, InjectionToken, Inject, HostListener, Component, Injector, ɵɵdefineInjectable, ɵɵinject, INJECTOR, NgModule } from '@angular/core';
import { Overlay, OverlayModule } from '@angular/cdk/overlay';
import { ComponentPortal, PortalInjector } from '@angular/cdk/portal';
import { timer, BehaviorSubject, defer, interval } from 'rxjs';
import { take, withLatestFrom, filter, map, share, reduce } from 'rxjs/operators';
import { CommonModule } from '@angular/common';

var NotificationData = /** @class */ (function () {
    function NotificationData() {
    }
    return NotificationData;
}());
var NotificationAlertContainerStyles = /** @class */ (function () {
    function NotificationAlertContainerStyles() {
    }
    return NotificationAlertContainerStyles;
}());
var DefaultNotificationConfig = /** @class */ (function () {
    function DefaultNotificationConfig() {
        this.animation = true;
        this.dismissible = true;
        this.position = 'topLeft';
        this.timeOut = 5;
        this.unique = false;
    }
    DefaultNotificationConfig = __decorate([
        Injectable()
    ], DefaultNotificationConfig);
    return DefaultNotificationConfig;
}());
var defaultNotificationCofigValues = {
    position: 'topRight',
    animation: true,
    timeOut: 5,
    dismissible: true,
};
var NOTIFICATION_CONFIG_TOKEN = new InjectionToken('notification-config');

var NgxNotificationRef = /** @class */ (function () {
    function NgxNotificationRef(overlay, nt) {
        this.overlay = overlay;
        this.nt = nt;
    }
    NgxNotificationRef.prototype.close = function () {
        this.overlay.dispose();
        this.clearMessage();
    };
    NgxNotificationRef.prototype.isVisible = function () {
        return this.overlay && this.overlay.overlayElement;
    };
    NgxNotificationRef.prototype.getPosition = function () {
        return this.overlay.overlayElement.getBoundingClientRect();
    };
    NgxNotificationRef.prototype.clearMessage = function () {
        this.nt.lastMessage = null;
    };
    return NgxNotificationRef;
}());

var NgxBootstrapAlertNotificationComponent = /** @class */ (function () {
    function NgxBootstrapAlertNotificationComponent(data, ref, containerStyles, notificationConfig) {
        this.data = data;
        this.ref = ref;
        this.containerStyles = containerStyles;
        this.notificationConfig = notificationConfig;
        this.animatedClass = 'fadeInDown';
    }
    NgxBootstrapAlertNotificationComponent.prototype.ngOnInit = function () {
        if (this.notificationConfig.dismissible) {
            this.dismissibleTimer();
        }
        this.show = true;
    };
    NgxBootstrapAlertNotificationComponent.prototype.close = function () {
        var _this = this;
        if (this.notificationConfig.animation) {
            this.animatedClass = 'fadeOutUp';
            this.show = false;
            timer(1000)
                .pipe(take(1))
                .subscribe(function (t) { return _this.ref.close(); });
        }
        else {
            this.show = false;
            this.ref.close();
        }
    };
    NgxBootstrapAlertNotificationComponent.prototype.onMouseOver = function () {
        if (this.notificationConfig.dismissible) {
            this.notification.paused.next(true);
        }
    };
    NgxBootstrapAlertNotificationComponent.prototype.onMouseLeave = function () {
        if (this.notificationConfig.dismissible) {
            this.notification.paused.next(false);
        }
    };
    NgxBootstrapAlertNotificationComponent.prototype.dismissibleTimer = function () {
        var _this = this;
        var subject = new BehaviorSubject(false);
        this.notification = {
            paused: subject,
            obs: this.getPausableTimer(this.notificationConfig.timeOut, subject),
        };
        this.notification.obs.completeTimer
            .pipe(take(1))
            .subscribe(function (t) { return _this.close(); });
    };
    NgxBootstrapAlertNotificationComponent.prototype.getPausableTimer = function (timeout, pause) {
        var pausableTimer$ = defer(function () {
            var seconds = 1;
            return interval(1000).pipe(withLatestFrom(pause), filter(function (_a) {
                var _b = __read(_a, 2), v = _b[0], paused = _b[1];
                return !paused;
            }), take(timeout), map(function () { return seconds++; }));
        }).pipe(share());
        return {
            stepTimer: pausableTimer$,
            completeTimer: pausableTimer$.pipe(reduce(function (x, y) { return y; })),
        };
    };
    NgxBootstrapAlertNotificationComponent.ctorParameters = function () { return [
        { type: NotificationData },
        { type: NgxNotificationRef },
        { type: NotificationAlertContainerStyles },
        { type: undefined, decorators: [{ type: Inject, args: [DefaultNotificationConfig,] }] }
    ]; };
    __decorate([
        HostListener('mouseover')
    ], NgxBootstrapAlertNotificationComponent.prototype, "onMouseOver", null);
    __decorate([
        HostListener('mouseleave')
    ], NgxBootstrapAlertNotificationComponent.prototype, "onMouseLeave", null);
    NgxBootstrapAlertNotificationComponent = __decorate([
        Component({
            selector: 'ngx-bootstrap-alert-notification',
            template: "\n    <div\n      [ngStyle]=\"containerStyles\"\n      class=\"col-11 col-sm-4 notification-container\"\n    >\n      <div\n        *ngIf=\"!data.template\"\n        [class.alert-dismissible]=\"notificationConfig.dismissible\"\n        [class.alert-with-icon]=\"data.icon\"\n        [class.animated]=\"notificationConfig.animation\"\n        [class.show]=\"show\"\n        [ngClass]=\"['alert-' + data.type, animatedClass]\"\n        class=\"alert fade\"\n        role=\"alert\"\n      >\n        <button\n          (click)=\"close()\"\n          aria-label=\"Close\"\n          class=\"close\"\n          type=\"button\"\n        >\n          <span aria-hidden=\"true\">\u00D7</span>\n        </button>\n        <h4 *ngIf=\"data.title as title\" class=\"title\">{{ title }}</h4>\n        <span\n          *ngIf=\"data.icon as icon\"\n          [className]=\"icon\"\n          data-notify=\"icon\"\n        ></span>\n        <span data-notify=\"message\">\n          {{ data.message }}\n        </span>\n      </div>\n      <ng-container\n        *ngIf=\"data.template as templateRef\"\n        [ngTemplateOutlet]=\"templateRef\"\n      ></ng-container>\n    </div>\n  ",
            styles: ["\n      :host {\n        z-index: 1051;\n        position: fixed;\n        display: block;\n      }\n\n      .title {\n        margin-bottom: 0;\n        color: white;\n      }\n\n      @keyframes fadeInDown {\n        from {\n          opacity: 0;\n          transform: translate3d(0, -100%, 0);\n        }\n\n        to {\n          opacity: 1;\n          transform: translate3d(0, 0, 0);\n        }\n      }\n\n      .fadeInDown {\n        animation-name: fadeInDown;\n      }\n\n      @keyframes fadeOutUp {\n        from {\n          opacity: 1;\n        }\n\n        to {\n          opacity: 0;\n          transform: translate3d(0, -100%, 0);\n        }\n      }\n\n      .fadeOutUp {\n        animation-name: fadeOutUp;\n      }\n\n      .animated {\n        animation-duration: 1s;\n        animation-fill-mode: both;\n      }\n    "]
        }),
        __param(3, Inject(DefaultNotificationConfig))
    ], NgxBootstrapAlertNotificationComponent);
    return NgxBootstrapAlertNotificationComponent;
}());

var Styles = {
    display: 'inline-block',
    margin: '0px auto',
    position: 'fixed',
    transition: 'all 0.5s ease-in-out',
    zIndex: '1031',
};
var NgxBootstrapAlertNotificationService = /** @class */ (function () {
    function NgxBootstrapAlertNotificationService(overlay, parentInjector, notificationConfig) {
        this.overlay = overlay;
        this.parentInjector = parentInjector;
        this.notificationConfig = notificationConfig;
    }
    NgxBootstrapAlertNotificationService_1 = NgxBootstrapAlertNotificationService;
    Object.defineProperty(NgxBootstrapAlertNotificationService.prototype, "lastMessage", {
        set: function (value) {
            this._lastMessage = value;
        },
        enumerable: true,
        configurable: true
    });
    NgxBootstrapAlertNotificationService.prototype.show = function (data, config) {
        if (!config ||
            (config && !config.unique) ||
            (config &&
                config.unique &&
                ((Array.isArray(this._lastMessage) &&
                    (this._lastMessage || []).includes(data.message)) ||
                    this._lastMessage !== data.message))) {
            this._lastMessage = data.message;
            var positionStrategy = this.getPositionStrategy();
            var overlayRef = this.overlay.create({ positionStrategy: positionStrategy });
            var notificationRef = new NgxNotificationRef(overlayRef, this.parentInjector.get(NgxBootstrapAlertNotificationService_1));
            var injector = this.getInjector(data, notificationRef, this.parentInjector, config, this.createContainerStyles(config));
            this.lastNotification = notificationRef;
            var toastPortal = new ComponentPortal(NgxBootstrapAlertNotificationComponent, null, injector);
            overlayRef.attach(toastPortal);
            return notificationRef;
        }
        return null;
    };
    NgxBootstrapAlertNotificationService.prototype.getPositionStrategy = function () {
        return this.overlay.position().global();
    };
    NgxBootstrapAlertNotificationService.prototype.getInjector = function (data, notificationRef, parentInjector, notificationConfig, containerStyles) {
        var tokens = new WeakMap();
        tokens.set(NotificationData, data);
        tokens.set(NgxNotificationRef, notificationRef);
        if (notificationConfig) {
            notificationConfig = __assign(__assign({}, this.notificationConfig), notificationConfig);
            tokens.set(DefaultNotificationConfig, notificationConfig);
        }
        if (containerStyles) {
            tokens.set(NotificationAlertContainerStyles, containerStyles);
        }
        return new PortalInjector(parentInjector, tokens);
    };
    NgxBootstrapAlertNotificationService.prototype.createContainerStyles = function (config) {
        var styles = __assign({}, Styles);
        var notificationContainer;
        if (this.lastNotification) {
            var element = this.lastNotification.isVisible();
            notificationContainer = element
                ? element.querySelector('.notification-container')
                : null;
        }
        var conf = __assign(__assign({}, this.notificationConfig), (config || {}));
        if (conf.position && conf.position.includes('top')) {
            styles.top =
                notificationContainer && notificationContainer.style.top
                    ? parseFloat(notificationContainer.style.top) +
                        notificationContainer.clientHeight + "px"
                    : '20px';
            switch (conf.position) {
                case 'topLeft':
                    styles.left = '20px';
                    break;
                case 'topCenter':
                    styles.left = '0px';
                    styles.right = '0px';
                    break;
                case 'topRight':
                    styles.right = '20px';
                    break;
                default:
                    break;
            }
        }
        else {
            styles.bottom =
                notificationContainer && notificationContainer.style.bottom
                    ? parseFloat(notificationContainer.style.bottom) +
                        notificationContainer.clientHeight + "px"
                    : '20px';
            switch (conf.position) {
                case 'bottomLeft':
                    styles.left = '20px';
                    break;
                case 'bottomCenter':
                    styles.left = '0px';
                    styles.right = '0px';
                    break;
                case 'bottomRight':
                    styles.right = '20px';
                    break;
                default:
                    break;
            }
        }
        return styles;
    };
    var NgxBootstrapAlertNotificationService_1;
    NgxBootstrapAlertNotificationService.ctorParameters = function () { return [
        { type: Overlay },
        { type: Injector },
        { type: undefined, decorators: [{ type: Inject, args: [DefaultNotificationConfig,] }] }
    ]; };
    NgxBootstrapAlertNotificationService.ɵprov = ɵɵdefineInjectable({ factory: function NgxBootstrapAlertNotificationService_Factory() { return new NgxBootstrapAlertNotificationService(ɵɵinject(Overlay), ɵɵinject(INJECTOR), ɵɵinject(DefaultNotificationConfig)); }, token: NgxBootstrapAlertNotificationService, providedIn: "root" });
    NgxBootstrapAlertNotificationService = NgxBootstrapAlertNotificationService_1 = __decorate([
        Injectable({
            providedIn: 'root',
        }),
        __param(2, Inject(DefaultNotificationConfig))
    ], NgxBootstrapAlertNotificationService);
    return NgxBootstrapAlertNotificationService;
}());

var NgxBootstrapAlertNotificationModule = /** @class */ (function () {
    function NgxBootstrapAlertNotificationModule() {
    }
    NgxBootstrapAlertNotificationModule_1 = NgxBootstrapAlertNotificationModule;
    NgxBootstrapAlertNotificationModule.forRoot = function (config) {
        return {
            ngModule: NgxBootstrapAlertNotificationModule_1,
            providers: [
                {
                    provide: DefaultNotificationConfig,
                    useValue: config ? config : defaultNotificationCofigValues,
                },
            ],
        };
    };
    var NgxBootstrapAlertNotificationModule_1;
    NgxBootstrapAlertNotificationModule = NgxBootstrapAlertNotificationModule_1 = __decorate([
        NgModule({
            declarations: [NgxBootstrapAlertNotificationComponent],
            imports: [CommonModule, OverlayModule],
            entryComponents: [NgxBootstrapAlertNotificationComponent],
            exports: [NgxBootstrapAlertNotificationComponent],
        })
    ], NgxBootstrapAlertNotificationModule);
    return NgxBootstrapAlertNotificationModule;
}());

/*
 * Public API Surface of ngx-bootstrap-alert-notification
 */

/**
 * Generated bundle index. Do not edit.
 */

export { DefaultNotificationConfig, NOTIFICATION_CONFIG_TOKEN, NgxBootstrapAlertNotificationComponent, NgxBootstrapAlertNotificationModule, NgxBootstrapAlertNotificationService, NotificationAlertContainerStyles, NotificationData, defaultNotificationCofigValues, NgxNotificationRef as ɵa };
//# sourceMappingURL=benevideschissanga-ngx-bootstrap-alert-notification.js.map
